︠47673cfe-e92c-4901-9b80-04904dc38bcf︠


#Evaluate all cells via pressing the Shift+Return keys or the small "play" button in the menu.
#Newton polynomial: https://en.wikipedia.org/wiki/Newton_polynomial

These are the expression obtained when doing direct replacement in the equations
︡792c4ed2-bb8c-4ad5-8724-e738ad617ed9︡
︠252dace7-d6aa-4876-92fd-8b40082d946e︠

︡01d35fcf-be66-48f1-8f73-2537c2ae55cd︡
︠513a5313-b3a5-42a9-b292-b610239f6a2c︠
print("---- Forward QSS1 ----")

# qss1
from sage.symbolic.function_factory import function

var('t y0 ty r0 tr d0  td  e')

def evTau(self, t): return r0
tau = function("tau", nargs=1, eval_func=evTau)
def evY(self, t): return y0
y = function("y", nargs=1, eval_func=evY)
def evD(self, t): return d0
d = function("d", nargs=1, eval_func=evD)

# forward
forward = d(t + tau(t))
expression = (d(t + tau(t)) ==  y(t))


print("---- Forward d(t + tau(t)) ----")
print("Forward d(t + tau(t)) = %s" % forward.simplify())
print("Forward d(t + tau(t)) = %s" % forward.simplify_full())
print("expression = %s" % expression.simplify_full())
print("---- coefficients:----")
coeff0 = expression.substitute(t = 0) # .expand().collect(t)
print("do = %s" % solve(coeff0, d0)[0].right_hand_side().simplify_full()) #  .right_hand_side().simplify_full()



︡cb06cf61-68ca-4ff1-b059-e19781faec18︡{"stdout":"---- Forward QSS1 ----\n"}︡{"stdout":"(t, y0, ty, r0, tr, d0, td, e)\n"}︡{"stdout":"---- Forward d(t + tau(t)) ----\n"}︡{"stdout":"Forward d(t + tau(t)) = d0\n"}︡{"stdout":"Forward d(t + tau(t)) = d0\n"}︡{"stdout":"expression = d0 == y0\n"}︡{"stdout":"---- coefficients:----\n"}︡{"stdout":"do = y0\n"}︡{"done":true}︡
︠3a14ab65-372f-47df-ae95-371c27c023a2︠

︡cebe9a38-f8b2-40c2-91ac-136e8b78f1e2︡
︠365c39e8-9147-4ad3-a931-a1835d222cb9s︠

print("---- Forward QSS2 ----")


# qss2
from sage.symbolic.function_factory import function

var('t y0 y1 ty r0 r1 tr d0 d1 td  e')

def evTau(self, t): return r0 + r1* (t - tr)
tau = function("tau", nargs=1, eval_func=evTau)
def evY(self, t): return y0 + y1* (t - ty)
y = function("y", nargs=1, eval_func=evY)
def evD(self, t): return d0 + d1* (t - td)
d = function("d", nargs=1, eval_func=evD)

# forward
forward = d(t + tau(t))
expression = (d(t + tau(t)) ==  y(t))


print("---- Forward d(t + tau(t)) ----")
print("Forward d(t + tau(t)) = %s" % forward.simplify())
print("Forward d(t + tau(t)) = %s" % forward.simplify_full())
print("expression = %s" % expression.simplify_full())
print("---- coefficients:----")
coeff0 = expression.substitute(t = 0) # .expand().collect(t)
coeff0 = solve(coeff0, d0)[0].right_hand_side()
print("do = %s \n" % coeff0) #  .right_hand_side().simplify_full()

coeff1 = expression.substitute(d0 = coeff0) # .expand().collect(t)
coeff1 = solve(coeff1, d1)[0].right_hand_side()
print("d1 = %s \n" % coeff1 )

print("---- When new tau arrives:----")
coeff0_newTau = coeff0.substitute(td = tr+r0, d1=coeff1)
print("do = %s (same as the definition of y(tr)=%s)\n" %  (coeff0_newTau.simplify_full(), y(tr) )) #

print("---- When new y arrives:----")
coeff0_newTau = coeff0.substitute(td = ty+tau(ty), d1=coeff1)
print("do = %s (same as the definition of y(ty)=%s)\n" %  (coeff0_newTau.simplify_full(), y(ty) )) #

# print("---- coefficients: in case QSS1 (y1=0, r1=0)----")
# expression = expression.substitute(y1=0, r1=0)
# coeff0 = expression.substitute(t = 0) # .expand().collect(t)
# print("do = %s" % solve(coeff0, d0)[0].right_hand_side().simplify_full()) #  .right_hand_side().simplify_full()
# #coeff1 = expression.substitute(d0 = 0, y0 = 0, r0 = 0)
# coeff1 = expression - coeff0
# print("d1 = %s" % solve(coeff1, d1)[0].right_hand_side().simplify_full())


︡7d960aa7-41ff-4839-aa22-0efe7fc35f73︡{"stdout":"---- Forward QSS2 ----\n"}︡{"stdout":"(t, y0, y1, ty, r0, r1, tr, d0, d1, td, e)\n"}︡{"stdout":"---- Forward d(t + tau(t)) ----\n"}︡{"stdout":"Forward d(t + tau(t)) = (r1*(t - tr) + r0 + t - td)*d1 + d0\n"}︡{"stdout":"Forward d(t + tau(t)) = -d1*r1*tr + d1*r0 + (d1*r1 + d1)*t - d1*td + d0\n"}︡{"stdout":"expression = -d1*r1*tr + d1*r0 + (d1*r1 + d1)*t - d1*td + d0 == (t - ty)*y1 + y0\n"}︡{"stdout":"---- coefficients:----\n"}︡{"stdout":"do = d1*r1*tr - d1*r0 + d1*td - ty*y1 + y0 \n\n"}︡{"stdout":"d1 = y1/(r1 + 1) \n\n"}︡{"stdout":"---- When new tau arrives:----\n"}︡{"stdout":"do = (tr - ty)*y1 + y0 (same as the definition of y(tr)=(tr - ty)*y1 + y0)\n\n"}︡{"stdout":"---- When new y arrives:----\n"}︡{"stdout":"do = y0 (same as the definition of y(ty)=y0)\n\n"}︡{"done":true}︡
︠68a9e5f7-ef47-4a97-a0ef-d1ad3d81ccea︠

︡625545b2-ab36-484c-a51b-127306b0b4c8︡
︠e83d0715-ff19-45b0-a203-758098fd2046s︠
print("---- Forward QSS3 ----")
# qss3
from sage.symbolic.function_factory import function

var('t T_y T_r T_d y_0 y_1 y_2 r_0 r_1 r_2 d_0 d_1 d_2')

def evTau(self, t): return r_0 + r_1* (t - T_r) + r_2* (t - T_r)^2
tau = function("tau", nargs=1, eval_func=evTau)
def evY(self, t): return y_0 + y_1* (t - T_y) + y_2* (t - T_y)^2
y = function("y", nargs=1, eval_func=evY)
def evD(self, t): return d_0 + d_1* (t - T_d) + d_2* (t - T_d)^2
d = function("d", nargs=1, eval_func=evD)


# forward
forward = d(t + tau(t))

print("---- Forward d(t + tau(t)) ----")
print("Forward d(t + tau(t)) = %s \n" % forward.simplify())
print("Forward d(t + tau(t)) simplified = %s \n" % forward.simplify_full())

#forward = d_2*r2^2*t^4 + d_2*r2^2*tr^4 + 2*(d_2*r1 + d_2)*r2*t^3 - 2*(2*d_2*r2^2*t + d_2*r1*r2)*tr^3 + d_2*r0^2 + (d_2*r1^2 + 2*d_2*r1 + (2*d_2*r0 + d1)*r2 + d_2)*t^2 + d_2*td^2 + (6*d_2*r2^2*t^2 + d_2*r1^2 + 2*(3*d_2*r1 + d_2)*r2*t - 2*d_2*r2*td + (2*d_2*r0 + d1)*r2)*tr^2 + d1*r0 + (2*d_2*r0 + (2*d_2*r0 + d1)*r1 + d1)*t - (2*d_2*r2*t^2 + 2*d_2*r0 + 2*(d_2*r1 + d_2)*t + d1)*td - (4*d_2*r2^2*t^3 + 2*(3*d_2*r1 + 2*d_2)*r2*t^2 + (2*d_2*r0 + d1)*r1 + 2*(d_2*r1^2 + d_2*r1 + (2*d_2*r0 + d1)*r2)*t - 2*(2*d_2*r2*t + d_2*r1)*td)*tr + d0


# remove t^4 and t^3 (manually :-()
print("---- Removing 3 and 4 order ----")

forward = T_r^4*d_2*r_2^2 + T_r^2*d_2*r_1^2 + T_d^2*d_2 + d_2*r_0^2 + (6*T_r^2*d_2*r_2^2 + d_2*r_1^2 + 2*d_2*r_1 - (6*T_r*d_2*r_1 + 2*(T_d + 2*T_r)*d_2 - 2*d_2*r_0 - d_1)*r_2 + d_2)*t^2 - T_d*d_1 - (2*T_d*d_2 - d_1)*r_0 + (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 - (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2 - (4*T_r^3*d_2*r_2^2 + 2*T_r*d_2*r_1^2 + 2*T_d*d_2 - 2*d_2*r_0 + (2*(T_d + T_r)*d_2 - 2*d_2*r_0 - d_1)*r_1 - 2*(3*T_r^2*d_2*r_1 - 2*T_r*d_2*r_0 - T_r*d_1 + (2*T_d*T_r + T_r^2)*d_2)*r_2 - d_1)*t + d_0

print("d(t + tau(t)) = %s\n" % forward)
print("y(t) = %s \n" % y(t))
#
# results in
# t^0:
# T_y^2*y_2  +  - T_y*y_1  + y_0 = + d_0 + T_r^4*d_2*r_2^2 + T_r^2*d_2*r_1^2  + T_d^2*d_2 + d_2*r_0^2  - T_d*d_1 - (2*T_d*d_2 - d_1)*r_0 + (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 - (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2
# t^1:
# t* (y_1 - 2*T_y*y_2) = - t * (4*T_r^3*d_2*r_2^2 + 2*T_r*d_2*r_1^2 + 2*T_d*d_2 - 2*d_2*r_0 + (2*(T_d + T_r)*d_2 - 2*d_2*r_0 - d_1)*r_1 - 2*(3*T_r^2*d_2*r_1 - 2*T_r*d_2*r_0 - T_r*d_1 + (2*T_d*T_r + T_r^2)*d_2)*r_2 - d_1)
# t^2:
#t^2*y_2 = t^2 * (6*T_r^2*d_2*r_2^2 + d_2*r_1^2 + 2*d_2*r_1 - (6*T_r*d_2*r_1 + 2*(T_d + 2*T_r)*d_2 - 2*d_2*r_0 - d_1)*r_2 + d_2)


coeff0_y = T_y^2*y_2  +  - T_y*y_1  + y_0
coeff0_d = d_0 + T_r^4*d_2*r_2^2 + T_r^2*d_2*r_1^2  + T_d^2*d_2 + d_2*r_0^2  - T_d*d_1 - (2*T_d*d_2 - d_1)*r_0 + (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 - (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2
expression = (coeff0_y ==  coeff0_d)
print("expression = %s" % expression)
coeff0 = solve(expression, d_0)[0].right_hand_side()
print("do = %s \n" % coeff0.simplify_full()) #  .right_hand_side().simplify_full()


coeff1_y = y_1 - 2*T_y*y_2
coeff1_d = 4*T_r^3*d_2*r_2^2 + 2*T_r*d_2*r_1^2 + 2*T_d*d_2 - 2*d_2*r_0 + (2*(T_d + T_r)*d_2 - 2*d_2*r_0 - d_1)*r_1 - 2*(3*T_r^2*d_2*r_1 - 2*T_r*d_2*r_0 - T_r*d_1 + (2*T_d*T_r + T_r^2)*d_2)*r_2 - d_1
expression = (coeff1_y ==  coeff1_d)
coeff1 = solve(expression, d_1)[0].right_hand_side()
print("d1 = %s \n" % coeff1.simplify_full()) #  .right_hand_side().simplify_full()


coeff2_y = y_2
coeff2_d = 6*T_r^2*d_2*r_2^2 + d_2*r_1^2 + 2*d_2*r_1 - (6*T_r*d_2*r_1 + 2*(T_d + 2*T_r)*d_2 - 2*d_2*r_0 - d_1)*r_2 + d_2
expression = (coeff2_y ==  coeff2_d)
expression = expression.substitute(d_1 = coeff1)
coeff2 = solve(expression, d_2)[0].right_hand_side()
print("d2 = %s \n" % coeff2.simplify_full()) #  .right_hand_side().simplify_full()


print("---- When new tau arrives:----")
coeff0_newTau = coeff0.substitute(T_d = T_r+r_0, d_1=coeff1, d_2=coeff2)
print("do = %s )\n" %  coeff0_newTau.simplify_full()) #
print("y(T_r) = %s \n" %  y(T_r).simplify_full()) #


# expression = (forward ==  y(t))

# print("expression = %s" % expression)
# print("expression = %s" % y(t).expand())

# print("---- coefficients:----")
# coeff0 = expression.substitute(t = 0) # .expand().collect(t)
# coeff0 = solve(coeff0, d_0)[0].right_hand_side()
# print("do = %s \n" % coeff0.simplify_full()) #  .right_hand_side().simplify_full()

# coeff1 = expression.substitute(d_0 = coeff0) # .expand().collect(t)
# coeff1 = solve(coeff1, d_1)[0].right_hand_side()
# print("d1 = %s \n" % coeff1 )

# coeff2 = expression.substitute(d_1 = coeff1) # .expand().collect(t)
# coeff2 = solve(coeff2, d_2)[0].right_hand_side()
# print("d2 = %s \n"  % coeff2.simplify_full() )




︡02078be8-b097-4312-93c6-f77f2d9c1f8c︡{"stdout":"---- Forward QSS3 ----\n"}︡{"stdout":"(t, T_y, T_r, T_d, y_0, y_1, y_2, r_0, r_1, r_2, d_0, d_1, d_2)\n"}︡{"stdout":"---- Forward d(t + tau(t)) ----\n"}︡{"stdout":"Forward d(t + tau(t)) = ((T_r - t)^2*r_2 - (T_r - t)*r_1 - T_d + r_0 + t)^2*d_2 + ((T_r - t)^2*r_2 - (T_r - t)*r_1 - T_d + r_0 + t)*d_1 + d_0 \n\n"}︡{"stdout":"Forward d(t + tau(t)) simplified = T_r^4*d_2*r_2^2 + d_2*r_2^2*t^4 + T_r^2*d_2*r_1^2 - 2*(2*T_r*d_2*r_2^2 - (d_2*r_1 + d_2)*r_2)*t^3 + T_d^2*d_2 + d_2*r_0^2 + (6*T_r^2*d_2*r_2^2 + d_2*r_1^2 + 2*d_2*r_1 - (6*T_r*d_2*r_1 + 2*(T_d + 2*T_r)*d_2 - 2*d_2*r_0 - d_1)*r_2 + d_2)*t^2 - T_d*d_1 - (2*T_d*d_2 - d_1)*r_0 + (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 - (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2 - (4*T_r^3*d_2*r_2^2 + 2*T_r*d_2*r_1^2 + 2*T_d*d_2 - 2*d_2*r_0 + (2*(T_d + T_r)*d_2 - 2*d_2*r_0 - d_1)*r_1 - 2*(3*T_r^2*d_2*r_1 - 2*T_r*d_2*r_0 - T_r*d_1 + (2*T_d*T_r + T_r^2)*d_2)*r_2 - d_1)*t + d_0 \n\n"}︡{"stdout":"---- Removing 3 and 4 order ----\n"}︡{"stdout":"d(t + tau(t)) = T_r^4*d_2*r_2^2 + T_r^2*d_2*r_1^2 + T_d^2*d_2 + d_2*r_0^2 + (6*T_r^2*d_2*r_2^2 + d_2*r_1^2 + 2*d_2*r_1 - (6*T_r*d_2*r_1 + 2*(T_d + 2*T_r)*d_2 - 2*d_2*r_0 - d_1)*r_2 + d_2)*t^2 - T_d*d_1 - (2*T_d*d_2 - d_1)*r_0 + (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 - (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2 - (4*T_r^3*d_2*r_2^2 + 2*T_r*d_2*r_1^2 + 2*T_d*d_2 - 2*d_2*r_0 + (2*(T_d + T_r)*d_2 - 2*d_2*r_0 - d_1)*r_1 - 2*(3*T_r^2*d_2*r_1 - 2*T_r*d_2*r_0 - T_r*d_1 + (2*T_d*T_r + T_r^2)*d_2)*r_2 - d_1)*t + d_0\n\n"}︡{"stdout":"y(t) = (T_y - t)^2*y_2 - (T_y - t)*y_1 + y_0 \n\n"}︡{"stdout":"expression = T_y^2*y_2 - T_y*y_1 + y_0 == T_r^4*d_2*r_2^2 + T_r^2*d_2*r_1^2 + T_d^2*d_2 + d_2*r_0^2 - T_d*d_1 - (2*T_d*d_2 - d_1)*r_0 + (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 - (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2 + d_0\n"}︡{"stdout":"do = -T_r^4*d_2*r_2^2 - T_r^2*d_2*r_1^2 - T_d^2*d_2 - d_2*r_0^2 + T_y^2*y_2 + T_d*d_1 + (2*T_d*d_2 - d_1)*r_0 - (2*T_d*T_r*d_2 - 2*T_r*d_2*r_0 - T_r*d_1)*r_1 + (2*T_r^3*d_2*r_1 + 2*T_d*T_r^2*d_2 - 2*T_r^2*d_2*r_0 - T_r^2*d_1)*r_2 - T_y*y_1 + y_0 \n\n"}︡{"stdout":"d1 = -(4*T_r^3*d_2*r_2^2 + 2*T_r*d_2*r_1^2 + 2*T_d*d_2 - 2*d_2*r_0 + 2*((T_d + T_r)*d_2 - d_2*r_0)*r_1 - 2*(3*T_r^2*d_2*r_1 - 2*T_r*d_2*r_0 + (2*T_d*T_r + T_r^2)*d_2)*r_2 + 2*T_y*y_2 - y_1)/(2*T_r*r_2 - r_1 - 1) \n\n"}︡{"stdout":"d2 = -(r_2*y_1 - (2*(T_r + T_y)*r_2 - r_1 - 1)*y_2)/(8*T_r^3*r_2^3 - r_1^3 - 12*(T_r^2*r_1 + T_r^2)*r_2^2 - 3*r_1^2 + 6*(T_r*r_1^2 + 2*T_r*r_1 + T_r)*r_2 - 3*r_1 - 1) \n\n"}︡{"stdout":"---- When new tau arrives:----\n"}︡{"stdout":"do = (16*T_r^7*d_2*r_2^5 - 2*T_r^2*d_2*r_1^5 + 2*(T_r*d_2*r_0 - (T_d*T_r + 4*T_r^2)*d_2)*r_1^4 - 8*(7*T_r^6*d_2*r_1 - 2*T_r^5*d_2*r_0 + (2*T_d*T_r^5 + 5*T_r^6)*d_2)*r_2^4 + 4*(2*T_r*d_2*r_0 - (2*T_d*T_r + 3*T_r^2)*d_2)*r_1^3 + 4*(19*T_r^5*d_2*r_1^2 - 10*T_r^4*d_2*r_0 + (10*T_d*T_r^4 + 9*T_r^5)*d_2 - 2*(5*T_r^4*d_2*r_0 - (5*T_d*T_r^4 + 14*T_r^5)*d_2)*r_1)*r_2^3 - 2*T_d*T_r*d_2 + 2*T_r*d_2*r_0 + 4*(3*T_r*d_2*r_0 - (3*T_d*T_r + 2*T_r^2)*d_2)*r_1^2 - 2*(25*T_r^4*d_2*r_1^3 - 18*T_r^3*d_2*r_0 - 3*(6*T_r^3*d_2*r_0 - (6*T_d*T_r^3 + 19*T_r^4)*d_2)*r_1^2 + (18*T_d*T_r^3 + 7*T_r^4)*d_2 - 3*(12*T_r^3*d_2*r_0 - (12*T_d*T_r^3 + 13*T_r^4)*d_2)*r_1)*r_2^2 + 2*(4*T_r*d_2*r_0 - (4*T_d*T_r + T_r^2)*d_2)*r_1 + 2*(8*T_r^3*d_2*r_1^4 - 7*T_r^2*d_2*r_0 - (7*T_r^2*d_2*r_0 - (7*T_d*T_r^2 + 25*T_r^3)*d_2)*r_1^3 - 3*(7*T_r^2*d_2*r_0 - (7*T_d*T_r^2 + 9*T_r^3)*d_2)*r_1^2 + (7*T_d*T_r^2 + T_r^3)*d_2 - (21*T_r^2*d_2*r_0 - (21*T_d*T_r^2 + 11*T_r^3)*d_2)*r_1)*r_2 + (8*T_r^3*r_2^3 - r_1^3 - 12*(T_r^2*r_1 + T_r^2)*r_2^2 - 3*r_1^2 + 6*(T_r*r_1^2 + 2*T_r*r_1 + T_r)*r_2 - 3*r_1 - 1)*y_0 + ((T_r + T_y)*r_1^3 - (3*T_r^4 + 8*T_r^3*T_y)*r_2^3 + 3*(T_r + T_y)*r_1^2 + 6*(T_r^3 + 2*T_r^2*T_y + (T_r^3 + 2*T_r^2*T_y)*r_1)*r_2^2 + 3*(T_r + T_y)*r_1 - 2*((2*T_r^2 + 3*T_r*T_y)*r_1^2 + 2*T_r^2 + 3*T_r*T_y + 2*(2*T_r^2 + 3*T_r*T_y)*r_1)*r_2 + T_r + T_y)*y_1 + ((T_r^2 - 2*T_r*T_y - T_y^2)*r_1^3 - 2*(T_r^5 - 3*T_r^4*T_y - 4*T_r^3*T_y^2)*r_2^3 + 3*(T_r^2 - 2*T_r*T_y - T_y^2)*r_1^2 + (5*T_r^4 - 12*T_r^3*T_y - 12*T_r^2*T_y^2 + (5*T_r^4 - 12*T_r^3*T_y - 12*T_r^2*T_y^2)*r_1)*r_2^2 + T_r^2 - 2*T_r*T_y - T_y^2 + 3*(T_r^2 - 2*T_r*T_y - T_y^2)*r_1 - 2*(2*T_r^3 - 4*T_r^2*T_y - 3*T_r*T_y^2 + (2*T_r^3 - 4*T_r^2*T_y - 3*T_r*T_y^2)*r_1^2 + 2*(2*T_r^3 - 4*T_r^2*T_y - 3*T_r*T_y^2)*r_1)*r_2)*y_2)/(8*T_r^3*r_2^3 - r_1^3 - 12*(T_r^2*r_1 + T_r^2)*r_2^2 - 3*r_1^2 + 6*(T_r*r_1^2 + 2*T_r*r_1 + T_r)*r_2 - 3*r_1 - 1) )\n"}︡{"stdout":"\n"}︡{"stdout":"y(T_r) = (T_r - T_y)*y_1 + (T_r^2 - 2*T_r*T_y + T_y^2)*y_2 + y_0 \n\n"}︡{"done":true}︡
︠1fd5b49d-d762-4467-a5b5-4e7805b037aa︠
print("---- test:----")
from sage.symbolic.expression_conversions import PolynomialConverter
# to poly
c1 = forward
m=c1.list()
poly = c1.polynomial(SR)

print("c1 = %s" % c1)
print("m1 = %s" % m)
print("poly = %s" % poly)
vars = poly.variables()
poly.dict()

poly[1]
z = SR[vars]
z
# z.dict()
# polynomial(vars, coeffs)
︡8ff5b313-f079-4723-b83b-5a4b081ca234︡
︠f5c0f84b-1b5f-4ee7-9ca2-f6f5f628ddaa︠
print("---- coefficients: in case QSS2 (y2=0, r2=0)----")
expression = expression.substitute(y2=0, r2=0, d_2=0)
coeff0 = expression.substitute(t = 0) # .expand().collect(t)
coeff0 = solve(coeff0, d_0)[0].right_hand_side()
print("do = %s \n" % coeff0.simplify_full()) #  .right_hand_side().simplify_full()

coeff1 = expression.substitute(d_0 = coeff0) # .expand().collect(t)
coeff1 = solve(coeff1, d_1)[0].right_hand_side()
print("d1 = %s \n" % coeff1.simplify_full())


# print("---- coefficients: in case QSS1 (y2=0, r2=0, y1=0, r1=0)----")
# expression = expression.substitute(y1=0, r1=0, y2=0, r2=0)
# coeff0 = expression.substitute(t = 0) # .expand().collect(t)
# print("do = %s" % solve(coeff0, d0)[0].right_hand_side().simplify_full()) #  .right_hand_side().simplify_full()
# #coeff1 = expression.substitute(d0 = 0, y0 = 0, r0 = 0)
# coeff1 = expression - coeff0
# print("d1 = %s" % solve(coeff1, d1)[0].right_hand_side().simplify_full())
︡1bcabc5d-2757-4b5e-891a-11934c476f12︡
︠1b0c1b52-ee04-4b56-8790-6162b1bcb652︠
︡2fd7a781-1c5a-46c3-9ddd-4809c2e42a80︡{"done":true}︡
︠f5deb138-aadb-4958-9d85-3226c8332eed︠

︡1390cbbd-b362-4983-9a8e-14cfdac25ed7︡{"done":true}︡










